<cfscript>
	import yaknow.closures.Closure;
	import yaknow.Utils;
	Utils = new Utils();
	
	Utils.demoStart("Closure Creation From Source");
	
	function exampleClosure()
	{
		var closure = new Closure(["c,d","return variables.a + variables.b + c + d;"],local);
		var a = 2;
		var b = 3;
		
		return closure;
	}
	
	closure = exampleClosure();
	result = closure.call(1,2);
	
	Utils.demoEnd([result]);
	
	Utils.demoStart("Closure Creation from Function (Map)");
	
	function uppercase(value,variables) { return uCase(value); }
	
	closure = new Closure(uppercase,variables);
	result = closure.map(["elliott","sean","ben","adam","dan"]);
	
	Utils.demoEnd([result]);
	
	Utils.demoStart("Closure Application (Fold)");
	closure = new Closure(["e,v","arrayAppend(variables.steps,v); return e + v;"],variables);
	steps = [];
	total = closure.fold([1,2,3,4,5,6,7,8,9,10],0);
	
	Utils.demoEnd([steps,total]);
		
	//writeDump(getComponentMetaData("Closure"));
</cfscript>