<cfscript>
	import yaknow.prototype.Car;
	import yaknow.prototype.BetterCar;
	import yaknow.prototype.Prototype;
	import yaknow.Utils;
	Utils = new Utils();
	
	Utils.demoStart("Create the ideal car");
	
	car = new Car();
	
	betterCar = new BetterCar();
	betterCar.prototype = car;
	
	myCar = betterCar.new();
	//myCar.prototypeOptimized = true;
	
	myCar.setMaker("Nissan");
	myCar.setModel("240sx");
	myCar.setYear(1992);
	
	description = myCar.getDescription();
	
	Utils.demoEnd([description]);
	
	Utils.demoStart("Modify Prototype at runtime");
	
	string function car_getId()
	{
		return hash(this.getYear() & this.getModel() & this.getMaker());
	}
	
	car.prototype = new Prototype();
	car.prototype.getId = car_getId;
	id = myCar.getId();
	
	Utils.demoEnd([id]);
	
	function test()
	{
		return "abc";
	}
	
	car.prototype.getId = test;
	writeDump(myCar.getId());
		
	// Performance of possible optimizations
	Utils.demoStart("getModel() Called 10000 times");
	for( i=1; i lte 10000; i++ )
		myCar.getModel();
	Utils.demoEnd();
	
</cfscript>